		TITLE   RESIDENT MULTIPLEX PACKAGE CHECKER
		PAGE	,132
		IDEAL	; Note this is to be assembled by Borland's TASM
			; It will NOT assemble with MASM

;		This program is designed to be executed from a batch file.
;		It will check the installed state of multiplex trap software
;		If the software is loaded it will exit with codition code 2.
;		If the software is not loaded, it will exit with condition code
;		of 0. Returns 3 if there is no such handler in the table.
;		If you may not load the software it returns a condition of 1.
;		See the technical reference manuals for more details.
;		The purpose of this is to allow your batch file to
;		load and initialize resident DOS functions properly.

;		Copyright(C) Bender Consulting
;		PO Box 8685
;		Woodcliff Lake, NJ 07675
;		Programmed By A. L. Bender, M. D.
;		April 25, 1990

;		You are free to use this program for any endevor even for
;		commercial purposes.  No warranties expressed or implied,
;		Dishwasher and Microwave Safe, Biodegradable, Non Toxic
;		Please leave the copyright message intact.

MPXINT	    	=   	02FH	; Multiplex Interrupt
SHARE	    	=   	10H 	; Share Package
PRINT	   	=   	1	; PRINT Package
ASSIGN	    	=   	2	; Assign Package
APPEND	    	=  	0B7H	; Append Package
FCB		=	5DH	; FCB #1 (Beyond the drive byte)
INFOR		=	80H	; From CP/M Days, A real relic!

	    	SEGMENT		CODE PARA
	    	ASSUME		CS:CODE, DS:CODE, ES:CODE
		ORG		0100H
STRT:		MOV		AH, 9
		MOV		DX, OFFSET BANNER
		INT		21H
		MOV		SI, OFFSET INFOR
		XOR		AX,AX
		MOV		[PSWITCH],AL
		LODSB			; Count of chars in infor
		MOV		CX,AX
		ADD		CX, 2	;position it to end
LOOK:		LODSB
		CMP		AL, '/'	; Scan for option
		JZ		OPTLETS
		CMP		AL, '-' ; Either way is ok
		JZ		OPTLETS
		CMP		AL, 0	; No more info (I Guess 0DH works too)
		JZ		NONPRINT
		LOOP		LOOK	; loop over information buffer
		JMP		SHORT NONPRINT
OPTLETS:	LODSB
		AND		AL,5FH	;Fold it
		CMP		AL,'P'	;is it print?
		JNZ		NONPRINT
		MOV		[PSWITCH],AL
NONPRINT:    	CALL		CHKCALL	; Set Up AH properly
		MOV		AL, 0	; Get MPX Status (AH says which handler)
	    	INT		MPXINT	; Inquire as to what's happening
	    	CMP		AL,0FFH	; installed
	    	JNE		GETOUT	; 1 or 0 
	    	MOV		AL,2	; Installed already
GETOUT:		PUSH		AX	; Save Status to give to DOS
		ADD		AL, '0'
		MOV		[RESULT], AL
		MOV		DX, OFFSET MSSG
		MOV		AH, 9	; Set up possible print
		MOV		AL, [PSWITCH]
		OR		AL,AL
		JZ		NOPRNT	; Don't print
		INT		21H
NOPRNT:		POP		AX
		MOV		AH, 4CH	; Exit Code
	    	INT		21H 	; Get out of here

; not the best way to do it but this is smaller than a sector
; and fast enough for any batch file
; Look at the first FCB (You CP/M people know this) to see
; what resident package you are going to check:

CHKCALL:	MOV		BX, 0	; Check all 4 states
		MOV		DI, OFFSET PROGS
CCL:		MOV		SI, OFFSET FCB
		MOV		CX, 6	; Look For 6 bytes
CLLOOP:		LODSB
		CMP		AL, ' '	; dont fold on blank
		JZ		NOFOLD
		AND		AL, 05FH; Fold To upper Case
NOFOLD:		CMP		AL, [BYTE PTR DI]
		JNZ		NXT
		INC		DI
		LOOP		CLLOOP
		MOV		AH, [PARAMS+BX]
		RET
NXT:		INC		BX		; incr to next group
		CMP		BX, 5	; done yet?
		JZ		DONE	; Yes
		MOV		AX,BX
		SHL		AX,1	; Actually its probably faster to multiply
		SHL		AX,1	; Multiply by 4
		ADD		AX,BX	; ADD Twice (Make it multiply by 6)
		ADD		AX,BX	; (All of these instructions require a fetch)
		MOV		DI, OFFSET PROGS
		ADD		DI, AX	; Point to new one
		JMP		SHORT CCL
DONE:		MOV		AL, 3	; No such multiplexed activity
		JMP		SHORT GETOUT
PSWITCH		DB		?	; Print Switch
PROGS		DB		"ASSIGN","APPEND","PRINT ","SHARE "
PARAMS		DB		ASSIGN, APPEND, PRINT, SHARE
MSSG		DB		10,13,"Multiplex Status Was: "
RESULT		DB		?,10,13,'$'
BANNER		DB		"Copyright (C) 1990,"
		DB		" Bender Consulting, "
		DB		"Woodcliff Lake, NJ 07675$"
		ENDS		CODE
  		END		STRT
